<?php

lt_include( PLOG_CLASS_PATH."class/action/admin/adminaction.class.php" );
lt_include( PLOG_CLASS_PATH."plugins/mtexport/class/view/adminmtexportpluginsettingsview.class.php" ); 

class AdminMTExportPluginExportBlogAction extends AdminAction 
{
	
  var $_cacheFolder;
  var $_pluginEnabled;
  var $_notifyGoogle;
  var $_fileLocation; 


  /**
   * Constructor. If nothing else, it also has to call the constructor of the parent
   * class, BlogAction with the same parameters
   */
  function AdminMTExportPluginExportBlogAction( $actionInfo, $request )
  {

    $this->AdminAction( $actionInfo, $request );

    $config =& Config::getConfig();


    $this->_cacheFolder = $config->getValue('temp_folder');
    $this->_cacheFolder = $this->_cacheFolder.'/mtexport/'.$this->_blogInfo->getId();
    if( !File::exists( $this->_cacheFolder )) {
      File::createDir( $this->_cacheFolder, 0755 );
    }

	  
  }
		
  function validate()
  {
    return true;
  }


  function htmlButTags($str) {

    // Take all the html entities
    $caracteres = get_html_translation_table(HTML_ENTITIES);
    // Find out the "tags" entities
    $remover = get_html_translation_table(HTML_SPECIALCHARS);
    // Spit out the tags entities from the original table
    $caracteres = array_diff($caracteres, $remover);
    // Translate the string....
    $str = strtr($str, $caracteres);
    // And that's it!
    // oo now amps
    $str = preg_replace("/&(?![A-Za-z]{0,4}\w{2,3};|#[0-9]{2,3};)/","&amp;" , $str);

    $str = mb_encode_numericentity ($str, array (0x0080, 0xffff, 0, 0xffff), "ISO-8859-1");
    
    return $str;
  } 

  function exportBlog()
  {
    lt_include( PLOG_CLASS_PATH."class/dao/articles.class.php");
	     
    // articles object
    $articles = new Articles;
    $users = new Users;

    // This kind of sucks.
    // We can't get all the articles and get the comments as we will run 
    // out of memory.  But what we are going to do is get
    // the first article, and then we will call getBlogNextArticle to go through the rest
    // Unfortunately, there is no easy way to get the first article without getting the 
    // whole list of articles
    $list = $articles->getBlogArticles(
                                       $this->_blogInfo->getId(),
                                       -1,  // date
                                       -1, // Get all articles
                                       0,  // all categories
                                       POST_STATUS_PUBLISHED  // only published articles
                                       );

    // Save this to a compressed file.
    $exportFile = $this->_cacheFolder."/mt-export.txt";
    $fd = fopen($exportFile,'w');


    if ( $fd && isset($list) && ( count($list) > 0 ) ) {

        // Get the first post
        $item = $list[count($list) - 1 ];

        unset( $list );

        // Iterate over the posts and create an entry for each.
        while ( $item ) {
          // Get the user of this post
          $userId = $item->getUserId();
          $userInfo = $users->getUserInfoFromId($userId);

          $username = $userInfo->getUserName();
          fwrite( $fd, "AUTHOR: " . $username . "\n" );
          unset( $username );
          
          // Write the title of the post
          fwrite( $fd, "TITLE: " . $item->getTopic() . "\n" );

          // The date of the post
          $dateObject =  $item->getDateObject();
          // Get the unix time stamp
            $time = $dateObject->getTimestamp(DATE_FORMAT_UNIXTIME);
            unset( $dateObject );
            $articleDate = date("m/d/Y G:i", $time);
            unset( $time );
            fwrite( $fd, "DATE: " . $articleDate . "\n" );
            unset( $articleDate );

            // Categories
            $categories = $item->getCategories();
            foreach ( $categories as $cat )
              {
                fwrite( $fd, "CATEGORY: " . $cat->getName() . "\n");
              }
            unset( $categories);
		
            // Status 
            // Since we are only looking at published items, we should default his to plublish
            fwrite( $fd, "STATUS: publish\n");

            // Allow comments
            $allowComments = $item->getCommentsEnabled() ? 1 : 0;
            fwrite( $fd, "ALLOW COMMENTS: " . $allowComments . "\n");
            unset($allowComments);
            fwrite ( $fd, "-----\n");

		     
            // Body
            fwrite ( $fd, "BODY:\n");
            fwrite ( $fd, $this->htmlButTags($item->getIntroText()));
            fwrite ( $fd, "\n-----\n");

            // extended body
            if ( $item->hasExtendedText() ) {
              fwrite ( $fd, "EXTENDED BODY:\n");
              fwrite ( $fd, $this->htmlButTags($item->getExtendedText()) );
              fwrite ( $fd, "\n-----\n");
            }
		     
            
            // Comments
            $comments = $item->getComments();
            foreach ( $comments as $comment ) {

              fwrite ( $fd, "COMMENT:\n");
              $commentUserName = $comment->getUserName();
              if ( $commentUserName && $commentUserName != "" ) {
                fwrite ( $fd, "AUTHOR: " . $commentUserName . "\n" );

              }
              unset($commentUserName);

              $commentDateObject =  $comment->getDateObject();
              // Get the unix time stamp
              $commentTime = $commentDateObject->getTimestamp(DATE_FORMAT_UNIXTIME);
              unset($commentDateObject);
              $commentDate = date("m/d/Y G:i", $commentTime);
              unset($commentTime);
              fwrite( $fd, "DATE: " . $commentDate . "\n" );
              unset($commentDate);

              // user email
              $commentUserEmail = $comment->getUserEmail();
              if ( $commentUserEmail && $commentUserEmail != "" ) {
                fwrite ( $fd, "EMAIL: " . $commentUserEmail . "\n" );
                unset($commentUserEmail);
              }

              // url
              $commentUserUrl = $comment->getUserUrl();
              if ($commentUserUrl && $commentUserUrl != "") {
                fwrite ( $fd, "URL: " . $commentUserUrl . "\n" );
                unset($commentUserUrl);
              }
              
              // client ip address
              fwrite ( $fd, "IP: " . $comment->getClientIp() . "\n" );
              fwrite ( $fd, $this->htmlButTags( $comment->getText()) );

              fwrite ( $fd, "\n-----\n"); 
              unset( $comment);
             
            }


            // End of the post item

            fwrite ( $fd, "--------\n");

            $nextArticle = $articles->getBlogNextArticle( $item );
            unset ($item);
            $item = $nextArticle;
          }
        fclose( $fd );
      }

    if( File::isReadable( $exportFile ) )
      File::chMod( $exportFile, 0644 );

    $this->_fileLocation = $exportFile;
    return true;
	
  }
		
  /**
   * Carries out the specified action
   */
  function perform()
  {
    // export the blogs
	  
    if( !$this->exportBlog( )) {
      $this->_view = new AdminMTExportPluginSettingsView( $this->_blogInfo );
      $this->_view->setErrorMessage( $this->_locale->tr("export_unsuccessful"));
      $this->setCommonData();

      return false;                       
    }

    $this->_view = new AdminMTExportPluginSettingsView( $this->_blogInfo );
    $this->_view->setSuccessMessage( $this->_locale->tr("export_saved_successful"));			
    $this->setCommonData();
			
    // clear the cache
    CacheControl::resetBlogCache( $this->_blogInfo->getId());					
            
    return true;		
  }
}
?>
